% Read the info from monthly Excel file in the new format, as of 2005

    clear
    clc;
    close all

    addpath(genpath([cd '\']));

    sInputDirectory     = 'CE_Excel_Files\';
    sOutputDirectory    = 'CE_Mat_files\';

    bRead_FullCoverage  = 1; % read forecasts where forecasts are available at institutions level;
    
    bReadNewFiles       = 0; % add new files to the end of the structure

%%  Define the countries for which the survey is being conducted
    vStringCountries_General        = fdefineNamesCountries_newformat;

%%  Create a vector with names of files
    vYears                          = 2005:1:2019;
    vStringMonths_firstletterbig    = {'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun','Jul','Aug','Sep','Oct','Nov','Dec'};

    vStringFileTitle                = fCreateNames_CFfiles_newformat(vYears, vStringMonths_firstletterbig, sInputDirectory);
    vStringFileTitle_new            = vStringFileTitle;                                
    
    save([sOutputDirectory 'sNamesExcelFiles.mat'], 'vStringFileTitle');
    
%%  Kill all the Excel processes
    fCloseExcelSessions;

%%  Store the Excel data in a structure for the full coverage countries

    structExcelData                 = repmat(struct([]),length(vStringFileTitle),1);
%     load('structExcelData.mat');
   
    if bRead_FullCoverage
        
        if ~bReadNewFiles
            
            for iFile = 1:length(vStringFileTitle) 

                iFile

                % Read data and info from file
                sFileTitle          = vStringFileTitle{iFile};
                
                if length(sFileTitle) == 13;
                sPathTitle          = strcat(sInputDirectory, sFileTitle(end-7:end-4),'\',sFileTitle);
                elseif length(sFileTitle) == 14
                    sPathTitle          = strcat(sInputDirectory, sFileTitle(end-8:end-5),'\',sFileTitle);
                end
                    
                    
                % Read the names of all sheets of the file
                [~,vNames_Sheets]   = xlsfinfo(sPathTitle);
                % Delete the sheets that don't correspond to countries in the predefined list of countries
                vNames_Sheets(~ismember(vNames_Sheets, vStringCountries_General)) = [];
                nSheets             = length(vNames_Sheets);

                 for iSheet = 1:nSheets

                     
                     
                    % Read the data
                    sCountry            = vNames_Sheets{iSheet};
                    disp(['Read M: ' char(vStringFileTitle(iFile)) ' ' char(sCountry)]); % CS 
                    [Data, Header]      = xlsread(sPathTitle,sCountry);

                    % Store the data
                    structExcelData(iFile).Country(iSheet).Data             = Data;
                    structExcelData(iFile).Country(iSheet).Header           = Header;
                    structExcelData(iFile).Country(iSheet).CountryName      = vNames_Sheets(iSheet);

                 end

                save([sOutputDirectory 'structExcelData.mat'], 'structExcelData');

            end
        
            %  Save the data
            save([sOutputDirectory 'structExcelData.mat'], 'structExcelData', 'vStringFileTitle');
            
        else  % if new files need to be added to the existing created structure
            load('structExcelData.mat');
            % Find the indices of the new files (that were not previously in the list of files)
                                   
            indexNewFiles   = ismember(vStringFileTitle_new, vStringFileTitle)==0;
            vIndicesNewFiles = find(indexNewFiles);
            cNewFiles       = vStringFileTitle_new(indexNewFiles);
            
            for iFile = 1:length(vIndicesNewFiles)
            
                cNewFiles(iFile)
                % Read data and info from file
                                             
                sFileTitle          = vStringFileTitle_new{vIndicesNewFiles(iFile)};
                                
                if length(sFileTitle) == 13; %if .xls file:
                    sPathTitle          = strcat(sInputDirectory, sFileTitle(end-7:end-4),'\',sFileTitle);
                elseif length(sFileTitle) == 14 %if .xlsx file:
                    sPathTitle          = strcat( sInputDirectory, sFileTitle(end-8:end-5),'\',sFileTitle);
                end
                                                  
                %sPathTitle          = strcat('..\', sInputDirectory, sFileTitle(end-7:end-4),'\',sFileTitle);
                
                % Read the names of all sheets of the file
                [~,vNames_Sheets]   = xlsfinfo(sPathTitle);
                % Delete the sheets that don't correspond to countries in the predefined list of countries
                vNames_Sheets(~ismember(vNames_Sheets, vStringCountries_General)) = [];
                nSheets             = length(vNames_Sheets);

                 for iSheet = 1:nSheets

                    % Read the data
                    sCountry            = vNames_Sheets{iSheet};
                    [Data, Header]      = xlsread(sPathTitle,sCountry);

                    % Store the data
                    structExcelData(vIndicesNewFiles(iFile)).Country(iSheet).Data             = Data;
                    structExcelData(vIndicesNewFiles(iFile)).Country(iSheet).Header           = Header;
                    structExcelData(vIndicesNewFiles(iFile)).Country(iSheet).CountryName      = vNames_Sheets(iSheet);

                 end
                 
                 % For safety safe the structure after each new month read
                 save([sOutputDirectory 'structExcelData.mat'], 'structExcelData');
                
            end
            
            % Replace the old list of files read with the new one
            vStringFileTitle = vStringFileTitle_new;
            save([sOutputDirectory 'structExcelData.mat'], 'structExcelData', 'vStringFileTitle');
            
            end
    end
    

    
    
    
    