% Read the info from quarterly Excel file


    clear
    clc;
    close all

    addpath(genpath([cd '\']));

    sInputDirectory     = 'CE_Excel_Files\CE Quarterly Forecasts';
    sOutputDirectory    = 'CE_Mat_files\';
 
%%  Define the countries for which the survey is being conducted
    vStringCountries_General        = fdefineNamesCountries_newformat_Quarterly;

%%  Create a vector with names of files
    
    vStringFileTitle                = fCreateNames_CFfiles_Quarterly(vStringCountries_General, sInputDirectory);
    
%%  Kill all the Excel processes
    fCloseExcelSessions;

%%  Store the Excel data in a structure for the full coverage countries

    structExcelData_QuarterlyForecasts     = repmat(struct([]),length(vStringFileTitle),1);
        
    for iCountry = 1:length(vStringFileTitle) 

        vStringFileTitle(iCountry)

        % Read data and info from file
        sFileTitle          = vStringFileTitle{iCountry};
        sPathTitle          = strcat(sInputDirectory, '\',sFileTitle);
        % Read the names of all sheets of the file
        [~,vNames_Sheets]   = xlsfinfo(sPathTitle);
        nSheets             = length(vNames_Sheets);

         for iSheet = 1:nSheets

            % Read the data
            sVariable           = vNames_Sheets{iSheet};
            disp(['Read Q: ' char(vStringFileTitle(iCountry)) ' ' char(sVariable)]) % CS

            if ~strcmp(sVariable, 'Menu')
                [Data, Header]      = xlsread(sPathTitle,sVariable);

                
                % In September 2014 the monthly (08.09.14) and the
                % quarterly (15.09.14) publication dates differ which 
                % would yield an error in the codes later: Adjust quarterly 
                % date to the monthly one:
                [row_adjust, ~] = find(ismember(Header, '15/09/2014'));
                Header(row_adjust, 1) = {'08/09/2014'};
                
                % Store the data
                structExcelData_QuarterlyForecasts(iCountry).Info(iSheet-1).Data             = Data;
                structExcelData_QuarterlyForecasts(iCountry).Info(iSheet-1).Header           = Header;
                structExcelData_QuarterlyForecasts(iCountry).Info(iSheet-1).Variable_Name    = vNames_Sheets(iSheet);                           
                
            end

         end

        save([sOutputDirectory 'structExcelData_QuarterlyForecasts.mat'] , 'structExcelData_QuarterlyForecasts');

    end

    %  Save the data
    save([sOutputDirectory 'structExcelData_QuarterlyForecasts.mat'], 'structExcelData_QuarterlyForecasts', 'vStringFileTitle');

    
    
    
    
    