% Function that creates a vector of string names of files that store
% Consensus Forecast data 
function vStringFileTitle = fCreateNames_CFfiles_oldformat(vYears, vStringMonths_smallcaps, vStringMonths_bigcaps, vStringMonths_firstletterbig, sInputDirectory)

    k = 1;
    
    for iYears = 1:length(vYears)

        for jMonths = 1:length(vStringMonths_firstletterbig)
            
            % Construct the name of the file - concatenate the year and the name of month in small caps
            sFileTitle  = strcat(vStringMonths_smallcaps{jMonths},num2str(vYears(iYears)),'.xls');
            sPathTitle  = strcat(sInputDirectory, num2str(vYears(iYears)),'\',sFileTitle);
            % Try opening the file for reading
            fid        = fopen(sPathTitle,'r'); % fid ==-1 stands for not able to open file
            
            if fid~=-1 % then the file with that name exists and it can be read in
                vStringFileTitle{k} = sFileTitle;
                k = k+1;
                fclose(fid);
            elseif fid==-1
                % Construct the name of the file - concatenate the year and the name of month in big caps
                sFileTitle  = strcat(vStringMonths_bigcaps{jMonths},num2str(vYears(iYears)),'.xls');
                sPathTitle  = strcat(sInputDirectory, num2str(vYears(iYears)),'\',sFileTitle);
                % Try opening the file for reading
                fid        = fopen(sPathTitle,'r'); % fid ==-1 stands for not able to open file
                if fid~=-1 % then the file with that name exists and it can be read in
                    vStringFileTitle{k} = sFileTitle;
                    k = k+1;
                    fclose(fid);
                elseif fid==-1
                     % Construct the name of the file - concatenate the year and the name of month with the first letter in capital
                    sFileTitle  = strcat(vStringMonths_firstletterbig{jMonths},num2str(vYears(iYears)),'.xls');
                    sPathTitle  = strcat(sInputDirectory, num2str(vYears(iYears)),'\',sFileTitle);
                    % Try opening the file for reading
                    fid        = fopen(sPathTitle,'r'); % fid ==-1 stands for not able to open file
                    if fid~=-1 % then the file with that name exists and it can be read in
                        vStringFileTitle{k} = sFileTitle;
                        k = k+1;
                        fclose(fid);
                    end
                end
            end

        end

    end



