
function [Header, Data] = fDeleteBlankColumn(Header, Data)

    % This column is the one for which in Data there are only NaN and in
    % Header there are only blanks spaces. The distance between the two is of 2 columns
    
    index_Data                              = find(sum(~isnan(Data))==0);
    index_Header                            = find(sum(~strcmp(deblank(Header), ''))==0);
    
    % Find the indices for which the Header has some data stored (i.e. the indices of columns which must not be deleted)
    index_noDelete                          = arrayfun (@(x) isempty(find(index_Header==x+2,1)), index_Data);
    index_Delete                            = not(index_noDelete);
    
    Header(:,index_Data(index_Delete)+2)    = [];
    Data(:,index_Data(index_Delete))        = [];