

    clearvars
    clc;
    close all

    addpath(genpath([cd '\']));
    
    sOutputGraphs       = 'Graphs\';
  
%%  Load structures with information
        
    load('Info_Gross Domestic Product_Mean_Q4_Rho0_Oct-1989_Mar-2019.mat'); % for GDP
    Info_GDP_Mean_Q4_rho0                   = Info; 
    
    nCountries             = length(Info_GDP_Mean_Q4_rho0);
   
%% Plot - Approx vs actual forecasts (rho = 0, rho = empirical) for mean 
    
    dLineWidth = 1.5;
    
    for iCountry = [1, 13]
        
        close all
        figure
        
       
        nDates          = length(Info_GDP_Mean_Q4_rho0(iCountry).Forecast);
        
        plot(1:nDates, Info_GDP_Mean_Q4_rho0(iCountry).Forecast,  '-k', 'LineWidth', dLineWidth);
        hold on
        plot(1:nDates, Info_GDP_Mean_Q4_rho0(iCountry).Forecast_ApprOptim,  '-b', 'LineWidth', dLineWidth);
        hold on
        plot(1:nDates, Info_GDP_Mean_Q4_rho0(iCountry).Forecast_Adhoc,  '-r', 'LineWidth', dLineWidth);
     
        dFontSize       = 15;
        set(gca,'FontSize',dFontSize);

        vDatesStr_plot  = datestr(Info_GDP_Mean_Q4_rho0(iCountry).Dates, 'mmm-yy');
        
        % find the index of the first March month
        index_first = find(strcmp(datestr(Info_GDP_Mean_Q4_rho0(iCountry).Dates, 'mmm'), {'Mar'}), 1)
        
         xlim([1 nDates]);
        if nDates >100
            vIndexXAxis = index_first:12:nDates;
        else
            vIndexXAxis = index_first:8:nDates;
        end
        
        set(gca,'XTick',vIndexXAxis);
        set(gca,'XTickLabel',vDatesStr_plot(vIndexXAxis,:));
        ylabel('percent');
       
        
        if iCountry ==1
            title(['US - GDP Growth Mean']);
        else
            title([Info_GDP_Mean_Q4_rho0(iCountry).Country ' - GDP Growth Mean']);  
        
        end
        
         if iCountry == nCountries
            legend('True fixed-horizon forecast', 'Optimal approximation (k = 0)',  ...
            'Ad-hoc approximation ','Location', 'SouthEast');   
        else
             legend('True fixed-horizon forecast', 'Optim approximation (k = 0)',  ...
            'Ad-hoc approximation ','Location', 'SouthWest');                   
         end

        sFileTitle = [Info_GDP_Mean_Q4_rho0(iCountry).Country 'MeanGDPrho0'];
       
        %%
        
        h = gcf;
        
        set(h, 'PaperUnits','centimeters');
        set(h,'PaperPosition', [1 1 28 19]);
        set(h,'PaperOrientation','landscape');
        % Save it in the pdf format for the paper
        print(gcf, '-dpdf', [sOutputGraphs sFileTitle]); 
%         print(gcf, '-depsc', [sOutputGraphs sFileTitle]); 
        
        
    end