

    clearvars
    clc;
    close all

    addpath(genpath([cd '\']));
    
    sOutputGraphs       = 'Graphs\';
   
%%  Load in data

    load('Info_Gross Domestic Product_Mean_Q4_Rho0_Oct-1989_Mar-2019.mat'); % for GDP
    Info_GDP_Mean_Q4_rho0       = Info; 
 
%% Plot1a - sum all MSEs for all countries and then average

    % V2 - add MSE and then compute
    close all
    nCountries      = length(Info_GDP_Mean_Q4_rho0);
    
    mPlot           = NaN(nCountries,4); 
    
    close all
    
     for iCountry = 1:nCountries 
        
        mPlot(iCountry,:)   = Info_GDP_Mean_Q4_rho0(iCountry).psi_allquarters;
        h(iCountry)         = plot(1:4,Info_GDP_Mean_Q4_rho0(iCountry).psi_allquarters, 'LineWidth',2);
        
        hold on
        vLegendString{iCountry} = Info_GDP_Mean_Q4_rho0(iCountry).Country;
        
        
     end
    
    vAverage_Psi = mean(mPlot);
    plot(1:4, vAverage_Psi, '--k', 'LineWidth',6);
   
    dFontSize       = 15;
    set(gca,'FontSize',dFontSize);

     vLegendString{nCountries+1} = 'Average';
     % Set the colors
    vColors = jet(numel(h));
    for ii = 1:numel(h)
            set(h(ii), 'color', vColors(ii,:))
    end
    
    legend(vLegendString, 'Location', 'NorthWest');
    legend('boxoff')
   
    quarters = ['Q1' ; 'Q2'; 'Q3'; 'Q4'];
    xlim([1 4]);
    ylim([0 1.6]);
    set(gca,'XTick',1:4);
    set(gca,'XTickLabel',quarters);
    
    title('GDP growth (mean across forecasters), Forecast Horizon = 4 quarters')
    
    sFileTitle = 'AvgRatios_MSE_Empirical_GDP_Mean_Rho0_Q4';
    h = gcf;
    set(h, 'PaperUnits','centimeters');
    set(h,'PaperPosition', [1 1 28 19]);
    set(h,'PaperOrientation','landscape');
    % Save it in the pdf format for the paper
    print(gcf, '-dpdf', [sOutputGraphs sFileTitle]); 
%     print(gcf, '-depsc', [sOutputGraphs sFileTitle]); 
    
