clc;
clearvars;
close all
% This uses the VARMA-section 6.3.2 of
% Ltkepohl's book 1993

m = 12;
rhovec = -0.99:0.01:0.99;
n = numel(rhovec);
yw_ar1coef = NaN(n,1);

i = 0;
for rho = rhovec
    i = i + 1;

    a11 = zeros(m,m);
    a11(1,1) = rho;
    a11(2:end,1:end-1) = eye(m-1);
    a12 = zeros(m,m-1);
    a12(1,:) = ones(1,m-1);
    a21 = zeros(m-1,m);
    a22 = zeros(m-1,m-1);
    a22(2:end,1:end-1) = eye(m-2);
    A = [[a11 a12] ; [a21 a22]];
    sigma_u = zeros(2*m-1,2*m-1);
    sigma_u(1,1) = 1;
    sigma_u(m+1,m+1) = 1;
    sigma_u(m+1,1) = 1;
    sigma_u(1,m+1) = 1;

    %sigma_y = inv( eye((2*m-1)^2) - kron(A,A)) * vec(sigma_u);
    sigma_y = inv( eye((2*m-1)^2) - kron(A,A)) * sigma_u(:);
    yw_ar1coef(i) = sigma_y(2)/sigma_y(1);
end

plot(rhovec,yw_ar1coef,'LineWidth',2);
xlabel('\rho');
