clc;
close all
clear all
expf_file_flag = 1;

quarters_known = -1; % 0 means current quarter known, -1 means only previous quarter known
rhovec = 0;
for current_quarter = 1:4
    w_opt_vec(current_quarter,1) =   optweights_ARp(4,rhovec,current_quarter+quarters_known,current_quarter+4,4);
end
w_adhoc_vec = [0.75;0.5;0.25;0.0];


for ii = 1:3
    if ii == 1
        cutoff_start = 0; %  cuts off first cutoff_start non-NAN-values
        cutoff_end = 0;   %  cuts off last cutoff_end non-NAN-values
        sheetname_exp = 'full sample'; % 1981q3 to 2023q2
    elseif ii == 2
        cutoff_start = 0; % cuts off first cutoff_start non-NAN-values
        cutoff_end = 14; % cuts off last cutoff_end non-NAN-values
        sheetname_exp = 'pre Covid'; % 1981q3 to 2019q4
    elseif ii == 3
        cutoff_start = 34; % cuts off first cutoff_start non-NAN-values
        cutoff_end = 16; % cuts off last cutoff_end non-NAN-values
        sheetname_exp = 'Consensus'; % 1989q1 to 2019q2
    end
    disp(sheetname_exp);


    stat_all_mat = [];
    for j = 1:2
        if j == 1
            sheetname = 'PGDP';
        elseif j == 2
            sheetname = 'RGDP';
        end
    
        %mat_prel = xlsread('AUS_ERSTER_REVISION_observations_and_forecasts_2023_May',sheetname);
        mat_prel = readmatrix('observations_and_forecasts_2023_May','Sheet',sheetname);
        mat = mat_prel(:,[1 32:34]);
        
    
        cygr = 100*( mat(:,3) ./ mat(:,2) - 1);
        nygr = 100*( mat(:,4) ./ mat(:,3)       - 1);
        year_quarter_vec = mat(:,1);
        yoy4q = mat_prel(:,14);
    
            [r,c] = size(mat);
        year_counter = 1;
        cygr_bq = NaN(300,4);
        nygr_bq = NaN(300,4);
        yoy4q_bq = NaN(300,4);
        year_quarter_bq = NaN(300,4);
        for i = 1:r
            year_quarter = year_quarter_vec(i,1);
            q = 4*(year_quarter-floor(year_quarter))+1;
            if q == 1
              year_counter = year_counter + 1;
            end
            %disp([year_counter q]);
    
            cygr_bq( year_counter,q) = cygr(i); 
            nygr_bq( year_counter,q) = nygr(i); 
            yoy4q_bq( year_counter,q) = yoy4q(i); 
            year_quarter_bq( year_counter,q) = year_quarter_vec(i); 
    
        end
        cygr_bq_prel  = cygr_bq;
        nygr_bq_prel  = nygr_bq;
        yoy4q_bq_prel = yoy4q_bq;
        year_quarter_bq_prel = year_quarter_bq;
        cygr_bq = cygr_bq( sum(isnan(cygr_bq_prel),2) ~= 4 ,:);
        nygr_bq = nygr_bq( sum(isnan(nygr_bq_prel),2) ~= 4 ,:);
        yoy4q_bq= yoy4q_bq( sum(isnan(cygr_bq_prel),2) ~= 4 ,:); 
        year_quarter_bq= year_quarter_bq( sum(isnan(cygr_bq_prel),2) ~= 4 ,:); 

        % sample starts 1981q3 at the earliest
        yoy4q_bq(1,1:2) = NaN(1,2);
        year_quarter_bq(1,1:2) = NaN(1,2);
        
        cygr_bq_vec  = reshape(cygr_bq' ,[],1);
        nygr_bq_vec  = reshape(nygr_bq' ,[],1);
        yoy4q_bq_vec = reshape(yoy4q_bq',[],1);
        year_quarter_vec = reshape(year_quarter_bq',[],1);
        [r,~] = size(cygr_bq_vec);
    
        [~,first_nonNaN_obs_cygr] = min(isnan(cygr_bq_vec));
        [~, last_nonNaN_obs_cygr] = min(isnan(cygr_bq_vec(end:-1:1)));
            last_nonNaN_obs_cygr  = r - last_nonNaN_obs_cygr + 1;
        cygr_bq_vec(first_nonNaN_obs_cygr:first_nonNaN_obs_cygr+cutoff_start-1) = NaN(cutoff_start,1);
        cygr_bq_vec(last_nonNaN_obs_cygr-cutoff_end+1:last_nonNaN_obs_cygr)     = NaN(cutoff_end,1);
        nygr_bq_vec(first_nonNaN_obs_cygr:first_nonNaN_obs_cygr+cutoff_start-1) = NaN(cutoff_start,1);
        nygr_bq_vec(last_nonNaN_obs_cygr-cutoff_end+1:last_nonNaN_obs_cygr)     = NaN(cutoff_end,1);
        yoy4q_bq_vec(first_nonNaN_obs_cygr:first_nonNaN_obs_cygr+cutoff_start-1) = NaN(cutoff_start,1);
        yoy4q_bq_vec(last_nonNaN_obs_cygr-cutoff_end+1:last_nonNaN_obs_cygr)    = NaN(cutoff_end,1);
    
        cygr_bq = reshape(cygr_bq_vec,4,[])';
        nygr_bq = reshape(nygr_bq_vec,4,[])';
        yoy4q_bq = reshape(yoy4q_bq_vec,4,[])';
    
        % cygr_bq_vec = cygr_bq_vec(cutoff_start+1:r-cutoff_end);
        % nygr_bq_vec = nygr_bq_vec(cutoff_start+1:r-cutoff_end);
        % yoy4q_bq_vec = yoy4q_bq_vec(cutoff_start+1:r-cutoff_end);
    
    
        % [r,c] = size(cygr_bq);
        % cygr_bq = cygr_bq(cutoff_start+1:r-cutoff_end,:);
        % nygr_bq = nygr_bq(cutoff_start+1:r-cutoff_end,:);
        % yoy4q_bq = yoy4q_bq(cutoff_start+1-cutoff_end:r,:);
    
    
        [r,c] = size(cygr_bq);
        w_opt_mat = ones(r,1) * w_opt_vec';
        fh_opt = w_opt_mat.*cygr_bq + (1-w_opt_mat).*nygr_bq;
    
        w_adhoc_mat = ones(r,1) * w_adhoc_vec';
        fh_adhoc = w_adhoc_mat.*cygr_bq + (1-w_adhoc_mat).*nygr_bq;
    
        fh_opt_vec   = reshape(fh_opt',[],1);
        fh_adhoc_vec = reshape(fh_adhoc',[],1);
        yoy4q_vec    = reshape(yoy4q_bq',[],1);
    
        % stat1 = [nanmean(cygr_bq(:)) nanmean(nygr_bq(:))];
        % stat2 = [nanstd(cygr_bq(:)) nanstd(nygr_bq(:))];   
        % stat3 = corr(cygr_bq(:),nygr_bq(:),'Rows','pairwise') ;
        % stat_all = [stat1  stat2  stat3];
        % stat_all_mat = [stat_all_mat ; stat_all];
    
        stat1 = [nanmean(cygr_bq(:)) nanmean(nygr_bq(:)) nanstd(cygr_bq(:)) nanstd(nygr_bq(:)) corr(cygr_bq(:),nygr_bq(:),'Rows','pairwise')];
        stat2 = [nanmean(fh_opt_vec) nanmean(fh_adhoc_vec) nanstd(fh_opt_vec) nanstd(fh_adhoc_vec) corr(fh_opt_vec,fh_adhoc_vec,'Rows','pairwise')];   
        
        stat_all = [stat1  NaN stat2 ];
        stat_all_mat = [stat_all_mat ; stat_all];
        %disp([ nanstd(nygr_bq) nanstd(cygr_bq) NaN nanstd(fh_opt) NaN nanstd(fh_adhoc)]); 
        
    end
    disp('1st line PGDP, second line GDP grwoth');
    disp('mean cy, mean ny, std cy, std ny, corr cy-ny ... mean fh_opt, mean fh_adhoc, std fh_opt, std fh_adhoc, corr fh_opt-fh_adhoc ... ');
    disp(stat_all_mat);
    
    if expf_file_flag == 1
        writematrix(stat_all_mat,'stat_all_mat_corrected.xlsx','Sheet',sheetname_exp,'Range','b2');
    end
end

%