function [mse_opt,mse_adhoc,mse_opt_q,mse_adhoc_q,approx_opt,approx_adhoc,weights_opt_c,weights_adhoc_c] = calc_mses(forecasts_annual_growth,forecast_target,start_quarter,w_opt,w_adhoc)


[nr , ~] = size( forecasts_annual_growth );
number_available_quarters_1styear = mod(5-start_quarter,4);
number_quarters_in_last_year = mod(nr-number_available_quarters_1styear,4);
number_quarters_full_years = nr-number_available_quarters_1styear-number_quarters_in_last_year;
number_full_years = number_quarters_full_years/4;

if numel(w_opt) == 4
    if start_quarter ~= 1
        weights_opt_c = [ w_opt(start_quarter:4)     ; kron(ones(number_full_years,1),w_opt)   ; w_opt(1:number_quarters_in_last_year)];        
    else
        weights_opt_c =   [ kron(ones(number_full_years,1),w_opt)       ; w_opt(1:number_quarters_in_last_year)];        
    end
else
    weights_opt_c = w_opt;
end

if numel(w_adhoc) == 4
    if start_quarter ~= 1        
        weights_adhoc_c = [ w_adhoc(start_quarter:4) ; kron(ones(number_full_years,1),w_adhoc) ; w_adhoc(1:number_quarters_in_last_year)];
    else        
        weights_adhoc_c = [ kron(ones(number_full_years,1),w_adhoc)     ; w_adhoc(1:number_quarters_in_last_year)];
    end
else
    weights_adhoc_c = w_adhoc;
end

% if start_quarter ~= 1
%     weights_opt_c = [ w_opt(start_quarter:4)     ; kron(ones(number_full_years,1),w_opt)   ; w_opt(1:number_quarters_in_last_year)];
%     weights_adhoc_c = [ w_adhoc(start_quarter:4) ; kron(ones(number_full_years,1),w_adhoc) ; w_adhoc(1:number_quarters_in_last_year)];
% else
%     weights_opt_c =   [ kron(ones(number_full_years,1),w_opt)       ; w_opt(1:number_quarters_in_last_year)];
%     weights_adhoc_c = [ kron(ones(number_full_years,1),w_adhoc)     ; w_adhoc(1:number_quarters_in_last_year)];
% end

approx_opt = weights_opt_c.*forecasts_annual_growth(:,1) + (1-weights_opt_c).*forecasts_annual_growth(:,2);
approx_adhoc = weights_adhoc_c.*forecasts_annual_growth(:,1) + (1-weights_adhoc_c).*forecasts_annual_growth(:,2);

mse_opt = nanmean( (approx_opt-forecast_target).^2);
mse_adhoc = nanmean( (approx_adhoc-forecast_target).^2);

err_opt_q   = highfrequency_vector_to_years_times_x_matrix( approx_opt-forecast_target ,4,start_quarter);
err_adhoc_q = highfrequency_vector_to_years_times_x_matrix(approx_adhoc-forecast_target,4,start_quarter);

mse_opt_q = nanmean( err_opt_q.^2);
mse_adhoc_q = nanmean( err_adhoc_q.^2);
          
end