function [ b, stdb, sig_sq , resids ] = estimarp( y , p , constant_flag)
% estimates an AR(1)-process
%   Detailed explanation goes here
    y = y(~isnan(y));
    n = rows(y);
    if nargin == 2
        constant_flag = 1;
    end
    xreg = NaN(n-p,p);
    for i = 1:p
        xreg(:,i) = y(p-i+1:n-i);
    end
        
    if constant_flag == 1
        xreg = [ones(n-p,1) xreg];
    end
    yreg = y(p+1:n);

    [b,stdb,sig_sq] = lscov(xreg,yreg);
    
    resids = yreg - xreg * b;

end

