
% Calculates real-time quarterly levels of PGDP and RGDP 
% from Philadadelphia Fed
num_prev_quarters = 7;
for vari = 1:2
    if vari == 1
        all = xlsread(['.\DataInput\PQvQd_' data_download_time '.xlsx'],1,'b2:iz400');
        export_sheet = 'PGDP';
    elseif vari ==2
        all = xlsread(['.\DataInput\ROUTPUTQvQd_' data_download_time '.xlsx'],1,'b2:iz400');
        export_sheet = 'RGDP';
    end
    
    [~,c] = size(all);
    qvec = ( 1965.75:0.25:(1965.75+0.25*c-0.25) )';
    [~,a] = min(~isnan(all(:,1)));
    counter = 0;
    for i = 1:numel(qvec)
        
        b = a + counter;
        counter = counter + 1;    
        results(i,:) = [qvec(i) (all(b-num_prev_quarters:b-1,i))'];
    end
    quarternames = cell(1,7);
    quartername = 'cur.quar.-1';
    for i = 1:num_prev_quarters
        quarternames{i} = ['cur.quar.-' num2str(num_prev_quarters+1-i)];
    end
        
    xlswrite(['.\DataOutput\quarterly_levels_real_time_' data_download_time '.xlsx'],[{'year'} quarternames],export_sheet,'a1');
    xlswrite(['.\DataOutput\quarterly_levels_real_time_' data_download_time '.xlsx'],results,export_sheet,'a2');
end


