clc;
clearvars -except data_download_time;
% Calculates real-time observations and forecasts



%if data for Q(x-1) [e.g. Q1] is already available, but forecasts from Q(x)
%[e.g. from May] ]are not [because it's beginning of May], set
% cutoff_observations = 1, to zero otherwise
cutoff_observations = 0;



for vari = 1:2
    if vari == 1
        export_sheet = 'PGDP';
    elseif vari ==2
        export_sheet = 'RGDP';
    end    
    observations = xlsread(['.\DataOutput\quarterly_levels_real_time_' data_download_time '.xlsx'],export_sheet,'a2:z400');
    forecasts    = xlsread(['.\DataInput\Mean_' export_sheet '_Level_' data_download_time  '.xlsx'],1           ,'a2:z400');
        % replace NaN for 1995q4 from shutdown in 1996q1 with vintage from 1996q2
        [~,ii] = max(isnan(observations));
        [~,jj] = max(ii);
        observations(max(ii),jj) = observations(max(ii)+1,jj-1);    
    %     [r,c] = size(observations);
    %     observations(ii,c) = observations(ii+1,c-1);
    
    % cut off first observations, because no corresponding forecasts available
    % observations = observations(13:end,:);
    % add observations to forecasts 
    
    observations = observations(1:(end-cutoff_observations),:);
    
    [~,c] = size(forecasts);
    forecasts = [NaN(12,c) ; forecasts];
    % Use backcasts from "forecasts", not from observations
    merged_q = [observations(:,1:7) forecasts(:,3:8)];
    % annualized qoq nowcasts would be given by
    nowcasts_qoq = 100 * ( (merged_q(:,9) ./ merged_q(:,8)).^4 - 1 );
    % annualized qoq backcasts, nowcasts and forecasts are given by
    forecasts_qoq = 100 * ( (merged_q(:,7:13) ./ merged_q(:,6:12)).^4 - 1 );
    % yoy backcasts, nowcasts and forecasts are given by
    forecasts_yoy = 100 * ( (merged_q(:,9:13) ./ merged_q(:,5:9)) - 1 );
    
    
    [r,c] = size(observations);
    for i = 1:r
        j = mod(i+2,4);
        observations_annual_prel(i,1:4) = observations(i,5-j:5-j+3);
    end
    observations_annual = mean(observations_annual_prel,2);
    forecasts_annual = [observations_annual forecasts(:,9:10)];
    ind = merged_q(:,1)==1985 | merged_q(:,1)==1986 | merged_q(:,1)==1990;
    forecasts_annual(ind,1:2) = forecasts_annual(ind,2:3);
    forecasts_annual(ind,3) = NaN;
    forecasts_annual_growth = 100* ( forecasts_annual(:,2:3) ./ forecasts_annual(:,1:2) - 1 );
    
    ec = {' '};
    header_qoq = {'qoq gr h=-2','qoq gr h=-1','qoq gr h=0', 'qoq gr h=1', 'qoq gr h=2', 'qoq gr h=3', 'qoq gr h=4'};
    header_yoy = {'yoy gr h=0', 'yoy gr h=1', 'yoy gr h=2', 'yoy gr h=3', 'yoy gr h=4'};
    header_anngr = {'ann gr h=0', 'ann gr h=1'};
    header_qlev = {'qrt lev h=-7','q lev h=-6','q lev h=-5','q lev h=-4','q lev h=-3','q lev h=-2','q lev h=-1','q lev h=0','q lev h=1','q lev h=2','q lev h=3','q lev h=4'};
    header_alev = {'ann lev h=-1','ann lev h=0','ann lev h=1'};
    
    xlswrite(['.\DataOutput\observations_and_forecasts_' data_download_time '.xlsx'],[{'quarter'},header_qoq,ec,header_yoy,ec,header_anngr,ec,header_qlev,ec,header_alev],export_sheet,'a1');
    xlswrite(['.\DataOutput\observations_and_forecasts_' data_download_time '.xlsx'],[merged_q(:,1) forecasts_qoq NaN(r,1) forecasts_yoy NaN(r,1) forecasts_annual_growth NaN(r,1) merged_q(:,2:13) NaN(r,1) forecasts_annual],export_sheet,'a2');

end

    